package main.com.iflytek;
import com.google.gson.Gson;
import com.google.gson.JsonObject;

import okhttp3.HttpUrl;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;
import okhttp3.WebSocket;
import okhttp3.WebSocketListener;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.nio.charset.Charset;
import java.text.SimpleDateFormat;
import java.util.*;
/*The default assessment example is Chinese sentence question type.
For other sample questions, please go to Demo to view sample questions and audio examples and note that you can modify the relevant evaluation parameters, or go to the bottom of the platform documentation to download sample audio questions.
Please go to the bottom of the platform document to download the audio sample test questions.*/
public class IseDemo extends WebSocketListener {
	private static final String hostUrl ="ws://ise-api-sg.xf-yun.com/v2/ise";
	private static final String appid = "appid";//Console Acquisition
	private static final String apiSecret = "apiSecret";//Console Acquisition
	private static final String apiKey = "apiKey";//Console Acquisition
	
	private static final String sub="ise";//Service type sub, open evaluation value ise
	private static final String ent="cn_vip";//language tag parameter ent(cn_vip-Chinese, en_vip-English)
	
	//The type of questions, text, audio, please note that to do synchronization changes (if the English assessment, please note that the value of the change ent parameter)
	private static final String category="read_sentence";//question type
	private static String text="What's the weather like today";//Evaluation test questions, English test questions:[content]\nthere was a gentleman live near my house.
	private static final String file = "iseAudio/cn/read_sentence_cn.pcm";//Review the audio, such as the transfer of mp3 format, please change the value of the parameter aue to lame

	public static final int StatusFirstFrame = 0;//First frame
	public static final int StatusContinueFrame = 1;//Middle Frame
	public static final int StatusLastFrame = 2;//Last frame

	final Base64.Encoder encoder = Base64.getEncoder();//Encoding
	final Base64.Decoder decoder = Base64.getDecoder();//decoding

	public static final Gson json = new Gson();
	/*private int aus = 1;
	private static Date dateBegin = new Date();// Begin time
	private static Date dateEnd = new Date();// End time
	private static final SimpleDateFormat sdf = new SimpleDateFormat("yyy-MM-dd HH:mm:ss.SSS");*/
	private static long beginTime=(new Date()).getTime();
	private static long endTime=(new Date()).getTime();
	public static void main(String[] args) throws Exception {
		System.out.println("The upcoming review text is："+text);
		String authUrl = getAuthUrl(hostUrl, apiKey, apiSecret);// Building a forensic url
		OkHttpClient client = new OkHttpClient.Builder().build();
		System.out.println(authUrl);
		String url = authUrl.replace("http://", "ws://");//Replace schema http:// and https:// respectively  in the url with ws:// and wss://
		Request request = new Request.Builder().url(url).build();
		System.out.println("url===>" + url);
		WebSocket webSocket = client.newWebSocket(request, new IseDemo());
	}
	//WebSocket handshake connection and upload audio data
	@Override
	public void onOpen(WebSocket webSocket, Response response) {
		super.onOpen(webSocket, response);
		new Thread(() -> {
			//Connection successful, start sending data
			int frameSize = 1280; //The size of each audio frame, it is recommended to send 1280B every 40ms, the size can be adjusted, but do not exceed 19200B, i.e. after base64 compression can exceed 26000B, otherwise it will be reported as Error 10163 data too long error.

			int intervel = 40;
			int status = 0;  // State of the audio
			//FileInputStream fs = new FileInputStream("0.pcm");
			ssb(webSocket);
			//ttp(webSocket);
			beginTime=(new Date()).getTime();
			try (FileInputStream fs = new FileInputStream(file)) {
				byte[] buffer = new byte[frameSize];
				// Sending Audio
				end:
					while (true) {
						int len = fs.read(buffer);
						if (len == -1) {
							status = StatusLastFrame;  //Read the file and change status to 2.

						switch (status) {
						case StatusFirstFrame:   // First audio frame status = 0
							send(webSocket,1,1,Base64.getEncoder().encodeToString(Arrays.copyOf(buffer, len)));
							status=StatusContinueFrame;//Intermediate frames
							break;

						case StatusContinueFrame:  //Middle frame status = 1
							send(webSocket,2,1,Base64.getEncoder().encodeToString(Arrays.copyOf(buffer, len)));
							break;

						case StatusLastFrame:    // Last audio frame status = 2, signaling the end of audio sending
							send(webSocket,4,2,"");
							System.out.println("sendlast");
							endTime=(new Date()).getTime();
							System.out.println("Total using time："+(endTime-beginTime)+"ms");
							break end;
						}
						Thread.sleep(intervel); //Analog audio sampling delay
					}
				System.out.println("all data is send");
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}).start();
	}
	//Adding and sending upload parameters
	private void ssb(WebSocket webSocket) {
		ParamBuilder p = new ParamBuilder();
		p.add("common", new ParamBuilder()
		.add("app_id", appid)
				)
				.add("business", new ParamBuilder()
				.add("category", category)
				.add("rstcd", "utf8")

				//Groups: adult adult, youth (middle school, the effect is the same as setting pupil parameters), pupil elementary school
				/// Only Chinese text, word and sentence question types are supported
				//.add("group", "pupil")

				//Scoring threshold values: hard, common, easy
				//.add("group", "pupil") //.add("group", "pupil")
				//.add("check_type", "common")

				//School level: junior(grade 1,2) middle(grade 3,4) senior(grade 5,6)
				//Chinese questions only: sentence and chapter questions for elementary and middle school support
				//.add("grade", "junior")

				// Extra_ability conditions :ise_unite=1,rst=entirety
				//.add("ise_unite","1")
				//.add("rst","entirety")
				/*1. Full dimension (accuracy score, fluency score, completeness score), extra_ability value is multi_dimension.    
				  2. support factor error information display (sound, tone type is correct or not), extra_ability value for syll_phone_err_msg
				  3. Word base frequency information display (base frequency start value, end value), extra_ability value for pitch, only for words and sentences question type
			      4. (words and sentences are applicable, such as the selection of multiple capabilities, with a semicolon; separated by such as: syll_phone_err_msg; pitch; multi_dimension)*/
				//.add("extra_ability", "multi_dimension")

				// Add pinyin to a part of the test paper, with the restriction that the number of characters added to pinyin should not exceed one-third of the number of characters in the whole test paper.
				//jin1|tian1|weather how to support

				//Score system conversion, rst=entirety is the default value, please choose to use percent system according to the recommendation of the document.


				.add("sub",sub)
				.add("ent",ent)
				.add("tte", "utf-8")
				.add("cmd", "ssb")
				.add("auf", "audio/L16;rate=16000")
				.add("aue", "raw")
				// Review Text (new String(new byte[] { (byte) 0xEF, (byte) 0xBB, (byte) 0xBF })+text)
				.add("text",'\uFEFF'+text)//Base64.getEncoder().encodeToString(text.getBytes())
						).add("data", new ParamBuilder()
						.add("status", 0)
						.add("data", ""));
		//System.err.println(p.toString());
		webSocket.send(p.toString());
	}
	//Client sends data to the server
	public void send(WebSocket webSocket, int aus,int status, String data) {
		ParamBuilder p = new ParamBuilder();
		p.add("business", new ParamBuilder()
		.add("cmd", "auw")
		.add("aus", aus)
		.add("aue", "raw")
				).add("data",new ParamBuilder()
				.add("status",status)
				.add("data",data)
				.add("data_type",1)
				.add("encoding","raw")
						);
		//System.out.println("Sending data"+p.toString());
		webSocket.send(p.toString());
	}
	//sever receives data from client
	@Override
	public void onMessage(WebSocket webSocket, String text) {
		super.onMessage(webSocket, text);
		//System.out.println(text);
		IseNewResponseData resp = json.fromJson(text, IseNewResponseData.class);
		if (resp != null) {
			if (resp.getCode() != 0) {
				System.out.println( "code=>" + resp.getCode() + " error=>" + resp.getMessage() + " sid=" + resp.getSid());
				System.out.println( "Error Code Query Link：https://global.xfyun.cn/doc/voiceservice/ise/API.html#description-of-the-interface");
				return;
			}
			if (resp.getData() != null) {
				if (resp.getData().getData() != null) {
					//Intermediate results processing
				}
				if (resp.getData().getStatus() == 2) {
					try {
						System.out.println("sid:"+resp.getSid()+" Final identification results"+new String(decoder.decode(resp.getData().getData()), "UTF-8"));
					} catch (Exception e) {
						e.printStackTrace();
					}
					webSocket.close(1000, "");
				} else {
					// todo Processing based on returned data
				}
			}
		}
		//System.out.println("response==>"+text);
	}
	//authentication
	public static String getAuthUrl(String hostUrl, String apiKey, String apiSecret) throws Exception {
		URL url = new URL(hostUrl);
		SimpleDateFormat format = new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss z", Locale.US);
		format.setTimeZone(TimeZone.getTimeZone("GMT"));
		String date = format.format(new Date());
		//String date = format.format(new Date());
		//System.err.println(date);
		StringBuilder builder = new StringBuilder("host: ").append(url.getHost()).append("\n").//
				append("date: ").append(date).append("\n").//
				append("GET ").append(url.getPath()).append(" HTTP/1.1");
		//System.err.println(builder);
		Charset charset = Charset.forName("UTF-8");
		Mac mac = Mac.getInstance("hmacsha256");
		SecretKeySpec spec = new SecretKeySpec(apiSecret.getBytes(charset), "hmacsha256");
		mac.init(spec);
		byte[] hexDigits = mac.doFinal(builder.toString().getBytes(charset));
		String sha = Base64.getEncoder().encodeToString(hexDigits);
		//System.err.println(sha);
		String authorization = String.format("api_key=\"%s\", algorithm=\"%s\", headers=\"%s\", signature=\"%s\"", apiKey, "hmac-sha256", "host date request-line", sha);
		//System.err.println(authorization);
		HttpUrl httpUrl = HttpUrl.parse("https://" + url.getHost() + url.getPath()).newBuilder().//
				addQueryParameter("authorization", Base64.getEncoder().encodeToString(authorization.getBytes(charset))).//
				addQueryParameter("date", date).//
				addQueryParameter("host", url.getHost()).//
				build();
		return httpUrl.toString();
	}
	//JSON analyze
	private static class IseNewResponseData{
		private int code;
		private String message;
		private String sid;
		private Data data;
		public int getCode() {
			return code;
		}
		public void setCode(int code) {
			this.code = code;
		}
		public String getMessage() {
			return message;
		}
		public void setMessage(String message) {
			this.message = message;
		}
		public String getSid() {
			return sid;
		}
		public void setSid(String sid) {
			this.sid = sid;
		}
		public Data getData() {
			return data;
		}
		public void setData(Data data) {
			this.data = data;
		}
	}
	private static class Data{
		private int status;
		private String data;
		public int getStatus() {
			return status;
		}
		public void setStatus(int status) {
			this.status = status;
		}
		public String getData() {
			return data;
		}
		public void setData(String data) {
			this.data = data;
		}
	}
	//Passing Parameter Construction
	public static class ParamBuilder {
		private JsonObject jsonObject = new JsonObject();
		public ParamBuilder add(String key, String val) {
			this.jsonObject.addProperty(key, val);
			return this;
		}
		public ParamBuilder add(String key, int val) {
			this.jsonObject.addProperty(key, val);
			return this;
		}
		public ParamBuilder add(String key, boolean val) {
			this.jsonObject.addProperty(key, val);
			return this;
		}
		public ParamBuilder add(String key, float val) {
			this.jsonObject.addProperty(key, val);
			return this;
		}
		public ParamBuilder add(String key, JsonObject val) {
			this.jsonObject.add(key, val);
			return this;
		}
		public ParamBuilder add(String key, ParamBuilder val) {
			this.jsonObject.add(key, val.jsonObject);
			return this;
		}
		@Override
		public String toString() {
			return this.jsonObject.toString();
		}
	}
}

